job-specs: new job test spec files including test count and durations
[csit.git] / resources / libraries / bash / function / common.sh
1 # Copyright (c) 2020 Cisco and/or its affiliates.
2 # Copyright (c) 2020 PANTHEON.tech and/or its affiliates.
3 # Licensed under the Apache License, Version 2.0 (the "License");
4 # you may not use this file except in compliance with the License.
5 # You may obtain a copy of the License at:
6 #
7 #     http://www.apache.org/licenses/LICENSE-2.0
8 #
9 # Unless required by applicable law or agreed to in writing, software
10 # distributed under the License is distributed on an "AS IS" BASIS,
11 # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
12 # See the License for the specific language governing permissions and
13 # limitations under the License.
14
15 set -exuo pipefail
16
17 # This library defines functions used by multiple entry scripts.
18 # Keep functions ordered alphabetically, please.
19
20 # TODO: Add a link to bash style guide.
21 # TODO: Consider putting every die into a {} block,
22 #   the code might become more readable (but longer).
23
24
25 function activate_docker_topology () {
26
27     # Create virtual vpp-device topology. Output of the function is topology
28     # file describing created environment saved to a file.
29     #
30     # Variables read:
31     # - BASH_FUNCTION_DIR - Path to existing directory this file is located in.
32     # - TOPOLOGIES - Available topologies.
33     # - NODENESS - Node multiplicity of desired testbed.
34     # - FLAVOR - Node flavor string, usually describing the processor.
35     # - IMAGE_VER_FILE - Name of file that contains the image version.
36     # - CSIT_DIR - Directory where ${IMAGE_VER_FILE} is located.
37     # Variables set:
38     # - WORKING_TOPOLOGY - Path to topology file.
39
40     set -exuo pipefail
41
42     source "${BASH_FUNCTION_DIR}/device.sh" || {
43         die "Source failed!"
44     }
45
46     device_image="$(< ${CSIT_DIR}/${IMAGE_VER_FILE})"
47     case_text="${NODENESS}_${FLAVOR}"
48     case "${case_text}" in
49         "1n_skx" | "1n_tx2")
50             # We execute reservation over csit-shim-dcr (ssh) which runs sourced
51             # script's functions. Env variables are read from ssh output
52             # back to localhost for further processing.
53             hostname=$(grep search /etc/resolv.conf | cut -d' ' -f3) || die
54             ssh="ssh root@${hostname} -p 6022"
55             run="activate_wrapper ${NODENESS} ${FLAVOR} ${device_image}"
56             # The "declare -f" output is long and boring.
57             set +x
58             # backtics to avoid https://midnight-commander.org/ticket/2142
59             env_vars=`${ssh} "$(declare -f); ${run}"` || {
60                 die "Topology reservation via shim-dcr failed!"
61             }
62             set -x
63             set -a
64             source <(echo "$env_vars" | grep -v /usr/bin/docker) || {
65                 die "Source failed!"
66             }
67             set +a
68             ;;
69         "1n_vbox")
70             # We execute reservation on localhost. Sourced script automatially
71             # sets environment variables for further processing.
72             activate_wrapper "${NODENESS}" "${FLAVOR}" "${device_image}" || die
73             ;;
74         *)
75             die "Unknown specification: ${case_text}!"
76     esac
77
78     trap 'deactivate_docker_topology' EXIT || {
79          die "Trap attempt failed, please cleanup manually. Aborting!"
80     }
81
82     # Replace all variables in template with those in environment.
83     source <(echo 'cat <<EOF >topo.yml'; cat ${TOPOLOGIES[0]}; echo EOF;) || {
84         die "Topology file create failed!"
85     }
86
87     WORKING_TOPOLOGY="/tmp/topology.yaml"
88     mv topo.yml "${WORKING_TOPOLOGY}" || {
89         die "Topology move failed!"
90     }
91     cat ${WORKING_TOPOLOGY} | grep -v password || {
92         die "Topology read failed!"
93     }
94 }
95
96
97 function activate_virtualenv () {
98
99     # Update virtualenv pip package, delete and create virtualenv directory,
100     # activate the virtualenv, install requirements, set PYTHONPATH.
101
102     # Arguments:
103     # - ${1} - Path to existing directory for creating virtualenv in.
104     #          If missing or empty, ${CSIT_DIR} is used.
105     # - ${2} - Path to requirements file, ${CSIT_DIR}/requirements.txt if empty.
106     # Variables read:
107     # - CSIT_DIR - Path to existing root of local CSIT git repository.
108     # Variables exported:
109     # - PYTHONPATH - CSIT_DIR, as CSIT Python scripts usually need this.
110     # Functions called:
111     # - die - Print to stderr and exit.
112
113     set -exuo pipefail
114
115     root_path="${1-$CSIT_DIR}"
116     env_dir="${root_path}/env"
117     req_path=${2-$CSIT_DIR/requirements.txt}
118     rm -rf "${env_dir}" || die "Failed to clean previous virtualenv."
119     pip3 install --upgrade virtualenv || {
120         die "Virtualenv package install failed."
121     }
122     virtualenv --python=$(which python3) "${env_dir}" || {
123         die "Virtualenv creation for $(which python3) failed."
124     }
125     set +u
126     source "${env_dir}/bin/activate" || die "Virtualenv activation failed."
127     set -u
128     pip3 install --upgrade -r "${req_path}" || {
129         die "Requirements installation failed."
130     }
131     # Most CSIT Python scripts assume PYTHONPATH is set and exported.
132     export PYTHONPATH="${CSIT_DIR}" || die "Export failed."
133 }
134
135
136 function archive_tests () {
137
138     # Create .tar.xz of generated/tests for archiving.
139     # To be run after generate_tests, kept separate to offer more flexibility.
140
141     # Directory read:
142     # - ${GENERATED_DIR}/tests - Tree of executed suites to archive.
143     # File rewriten:
144     # - ${ARCHIVE_DIR}/tests.tar.xz - Archive of generated tests.
145
146     set -exuo pipefail
147
148     tar c "${GENERATED_DIR}/tests" | xz -9e > "${ARCHIVE_DIR}/tests.tar.xz" || {
149         die "Error creating archive of generated tests."
150     }
151 }
152
153
154 function check_download_dir () {
155
156     # Fail if there are no files visible in ${DOWNLOAD_DIR}.
157     #
158     # Variables read:
159     # - DOWNLOAD_DIR - Path to directory pybot takes the build to test from.
160     # Directories read:
161     # - ${DOWNLOAD_DIR} - Has to be non-empty to proceed.
162     # Functions called:
163     # - die - Print to stderr and exit.
164
165     set -exuo pipefail
166
167     if [[ ! "$(ls -A "${DOWNLOAD_DIR}")" ]]; then
168         die "No artifacts downloaded!"
169     fi
170 }
171
172
173 function check_prerequisites () {
174
175     # Fail if prerequisites are not met.
176     #
177     # Functions called:
178     # - installed - Check if application is installed/present in system.
179     # - die - Print to stderr and exit.
180
181     set -exuo pipefail
182
183     if ! installed sshpass; then
184         die "Please install sshpass before continue!"
185     fi
186 }
187
188
189 function common_dirs () {
190
191     # Set global variables, create some directories (without touching content).
192
193     # Variables set:
194     # - BASH_FUNCTION_DIR - Path to existing directory this file is located in.
195     # - CSIT_DIR - Path to existing root of local CSIT git repository.
196     # - TOPOLOGIES_DIR - Path to existing directory with available topologies.
197     # - JOB_SPECS_DIR - Path to existing directory with job test specifications.
198     # - RESOURCES_DIR - Path to existing CSIT subdirectory "resources".
199     # - TOOLS_DIR - Path to existing resources subdirectory "tools".
200     # - PYTHON_SCRIPTS_DIR - Path to existing tools subdirectory "scripts".
201     # - ARCHIVE_DIR - Path to created CSIT subdirectory "archive".
202     # - DOWNLOAD_DIR - Path to created CSIT subdirectory "download_dir".
203     # - GENERATED_DIR - Path to created CSIT subdirectory "generated".
204     # Directories created if not present:
205     # ARCHIVE_DIR, DOWNLOAD_DIR, GENERATED_DIR.
206     # Functions called:
207     # - die - Print to stderr and exit.
208
209     set -exuo pipefail
210
211     this_file=$(readlink -e "${BASH_SOURCE[0]}") || {
212         die "Some error during locating of this source file."
213     }
214     BASH_FUNCTION_DIR=$(dirname "${this_file}") || {
215         die "Some error during dirname call."
216     }
217     # Current working directory could be in a different repo, e.g. VPP.
218     pushd "${BASH_FUNCTION_DIR}" || die "Pushd failed"
219     relative_csit_dir=$(git rev-parse --show-toplevel) || {
220         die "Git rev-parse failed."
221     }
222     CSIT_DIR=$(readlink -e "${relative_csit_dir}") || die "Readlink failed."
223     popd || die "Popd failed."
224     TOPOLOGIES_DIR=$(readlink -e "${CSIT_DIR}/topologies/available") || {
225         die "Readlink failed."
226     }
227     JOB_SPECS_DIR=$(readlink -e "${CSIT_DIR}/docs/job_specs") || {
228         die "Readlink failed."
229     }
230     RESOURCES_DIR=$(readlink -e "${CSIT_DIR}/resources") || {
231         die "Readlink failed."
232     }
233     TOOLS_DIR=$(readlink -e "${RESOURCES_DIR}/tools") || {
234         die "Readlink failed."
235     }
236     DOC_GEN_DIR=$(readlink -e "${TOOLS_DIR}/doc_gen") || {
237         die "Readlink failed."
238     }
239     PYTHON_SCRIPTS_DIR=$(readlink -e "${TOOLS_DIR}/scripts") || {
240         die "Readlink failed."
241     }
242
243     ARCHIVE_DIR=$(readlink -f "${CSIT_DIR}/archive") || {
244         die "Readlink failed."
245     }
246     mkdir -p "${ARCHIVE_DIR}" || die "Mkdir failed."
247     DOWNLOAD_DIR=$(readlink -f "${CSIT_DIR}/download_dir") || {
248         die "Readlink failed."
249     }
250     mkdir -p "${DOWNLOAD_DIR}" || die "Mkdir failed."
251     GENERATED_DIR=$(readlink -f "${CSIT_DIR}/generated") || {
252         die "Readlink failed."
253     }
254     mkdir -p "${GENERATED_DIR}" || die "Mkdir failed."
255 }
256
257
258 function compose_pybot_arguments () {
259
260     # Variables read:
261     # - WORKING_TOPOLOGY - Path to topology yaml file of the reserved testbed.
262     # - DUT - CSIT test/ subdirectory, set while processing tags.
263     # - TAGS - Array variable holding selected tag boolean expressions.
264     # - TOPOLOGIES_TAGS - Tag boolean expression filtering tests for topology.
265     # - TEST_CODE - The test selection string from environment or argument.
266     # Variables set:
267     # - PYBOT_ARGS - String holding part of all arguments for pybot.
268     # - EXPANDED_TAGS - Array of strings pybot arguments compiled from tags.
269
270     set -exuo pipefail
271
272     # No explicit check needed with "set -u".
273     PYBOT_ARGS=("--loglevel" "TRACE")
274     PYBOT_ARGS+=("--variable" "TOPOLOGY_PATH:${WORKING_TOPOLOGY}")
275
276     case "${TEST_CODE}" in
277         *"device"*)
278             PYBOT_ARGS+=("--suite" "tests.${DUT}.device")
279             ;;
280         *"perf"*)
281             PYBOT_ARGS+=("--suite" "tests.${DUT}.perf")
282             ;;
283         *)
284             die "Unknown specification: ${TEST_CODE}"
285     esac
286
287     EXPANDED_TAGS=()
288     for tag in "${TAGS[@]}"; do
289         if [[ ${tag} == "!"* ]]; then
290             EXPANDED_TAGS+=("--exclude" "${tag#$"!"}")
291         else
292             EXPANDED_TAGS+=("--include" "${TOPOLOGIES_TAGS}AND${tag}")
293         fi
294     done
295 }
296
297
298 function copy_archives () {
299
300     # Create additional archive if workspace variable is set.
301     # This way if script is running in jenkins all will be
302     # automatically archived to logs.fd.io.
303     #
304     # Variables read:
305     # - WORKSPACE - Jenkins workspace, copy only if the value is not empty.
306     #   Can be unset, then it speeds up manual testing.
307     # - ARCHIVE_DIR - Path to directory with content to be copied.
308     # Directories updated:
309     # - ${WORKSPACE}/archives/ - Created if does not exist.
310     #   Content of ${ARCHIVE_DIR}/ is copied here.
311     # Functions called:
312     # - die - Print to stderr and exit.
313
314     set -exuo pipefail
315
316     if [[ -n "${WORKSPACE-}" ]]; then
317         mkdir -p "${WORKSPACE}/archives/" || die "Archives dir create failed."
318         cp -rf "${ARCHIVE_DIR}"/* "${WORKSPACE}/archives" || die "Copy failed."
319     fi
320 }
321
322
323 function deactivate_docker_topology () {
324
325     # Deactivate virtual vpp-device topology by removing containers.
326     #
327     # Variables read:
328     # - NODENESS - Node multiplicity of desired testbed.
329     # - FLAVOR - Node flavor string, usually describing the processor.
330
331     set -exuo pipefail
332
333     case_text="${NODENESS}_${FLAVOR}"
334     case "${case_text}" in
335         "1n_skx" | "1n_tx2")
336             hostname=$(grep search /etc/resolv.conf | cut -d' ' -f3) || die
337             ssh="ssh root@${hostname} -p 6022"
338             env_vars=$(env | grep CSIT_ | tr '\n' ' ' ) || die
339             # The "declare -f" output is long and boring.
340             set +x
341             ${ssh} "$(declare -f); deactivate_wrapper ${env_vars}" || {
342                 die "Topology cleanup via shim-dcr failed!"
343             }
344             set -x
345             ;;
346         "1n_vbox")
347             enter_mutex || die
348             clean_environment || {
349                 die "Topology cleanup locally failed!"
350             }
351             exit_mutex || die
352             ;;
353         *)
354             die "Unknown specification: ${case_text}!"
355     esac
356 }
357
358
359 function die () {
360
361     # Print the message to standard error end exit with error code specified
362     # by the second argument.
363     #
364     # Hardcoded values:
365     # - The default error message.
366     # Arguments:
367     # - ${1} - The whole error message, be sure to quote. Optional
368     # - ${2} - the code to exit with, default: 1.
369
370     set -x
371     set +eu
372     warn "${1:-Unspecified run-time error occurred!}"
373     exit "${2:-1}"
374 }
375
376
377 function die_on_pybot_error () {
378
379     # Source this fragment if you want to abort on any failed test case.
380     #
381     # Variables read:
382     # - PYBOT_EXIT_STATUS - Set by a pybot running fragment.
383     # Functions called:
384     # - die - Print to stderr and exit.
385
386     set -exuo pipefail
387
388     if [[ "${PYBOT_EXIT_STATUS}" != "0" ]]; then
389         die "Test failures are present!" "${PYBOT_EXIT_STATUS}"
390     fi
391 }
392
393
394 function generate_tests () {
395
396     # Populate ${GENERATED_DIR}/tests based on ${CSIT_DIR}/tests/.
397     # Any previously existing content of ${GENERATED_DIR}/tests is wiped before.
398     # The generation is done by executing any *.py executable
399     # within any subdirectory after copying.
400
401     # This is a separate function, because this code is called
402     # both by autogen checker and entries calling run_pybot.
403
404     # Directories read:
405     # - ${CSIT_DIR}/tests - Used as templates for the generated tests.
406     # Directories replaced:
407     # - ${GENERATED_DIR}/tests - Overwritten by the generated tests.
408
409     set -exuo pipefail
410
411     rm -rf "${GENERATED_DIR}/tests" || die
412     cp -r "${CSIT_DIR}/tests" "${GENERATED_DIR}/tests" || die
413     cmd_line=("find" "${GENERATED_DIR}/tests" "-type" "f")
414     cmd_line+=("-executable" "-name" "*.py")
415     # We sort the directories, so log output can be compared between runs.
416     file_list=$("${cmd_line[@]}" | sort) || die
417
418     for gen in ${file_list}; do
419         directory="$(dirname "${gen}")" || die
420         filename="$(basename "${gen}")" || die
421         pushd "${directory}" || die
422         ./"${filename}" || die
423         popd || die
424     done
425 }
426
427
428 function get_test_code () {
429
430     # Arguments:
431     # - ${1} - Optional, argument of entry script (or empty as unset).
432     #   Test code value to override job name from environment.
433     # Variables read:
434     # - JOB_NAME - String affecting test selection, default if not argument.
435     # Variables set:
436     # - TEST_CODE - The test selection string from environment or argument.
437     # - NODENESS - Node multiplicity of desired testbed.
438     # - FLAVOR - Node flavor string, usually describing the processor.
439
440     set -exuo pipefail
441
442     TEST_CODE="${1-}" || die "Reading optional argument failed, somehow."
443     if [[ -z "${TEST_CODE}" ]]; then
444         TEST_CODE="${JOB_NAME-}" || die "Reading job name failed, somehow."
445     fi
446
447     case "${TEST_CODE}" in
448         *"1n-vbox"*)
449             NODENESS="1n"
450             FLAVOR="vbox"
451             ;;
452         *"1n-skx"*)
453             NODENESS="1n"
454             FLAVOR="skx"
455             ;;
456        *"1n-tx2"*)
457             NODENESS="1n"
458             FLAVOR="tx2"
459             ;;
460         *"2n-skx"*)
461             NODENESS="2n"
462             FLAVOR="skx"
463             ;;
464         *"3n-skx"*)
465             NODENESS="3n"
466             FLAVOR="skx"
467             ;;
468         *"2n-clx"*)
469             NODENESS="2n"
470             FLAVOR="clx"
471             ;;
472         *"2n-dnv"*)
473             NODENESS="2n"
474             FLAVOR="dnv"
475             ;;
476         *"3n-dnv"*)
477             NODENESS="3n"
478             FLAVOR="dnv"
479             ;;
480         *"3n-tsh"*)
481             NODENESS="3n"
482             FLAVOR="tsh"
483             ;;
484         *)
485             # Fallback to 3-node Haswell by default (backward compatibility)
486             NODENESS="3n"
487             FLAVOR="hsw"
488             ;;
489     esac
490 }
491
492
493 function get_test_tag_string () {
494
495     # Variables read:
496     # - GERRIT_EVENT_TYPE - Event type set by gerrit, can be unset.
497     # - GERRIT_EVENT_COMMENT_TEXT - Comment text, read for "comment-added" type.
498     # - TEST_CODE - The test selection string from environment or argument.
499     # Variables set:
500     # - TEST_TAG_STRING - The string following trigger word in gerrit comment.
501     #   May be empty, or even not set on event types not adding comment.
502
503     # TODO: ci-management scripts no longer need to perform this.
504
505     set -exuo pipefail
506
507     if [[ "${GERRIT_EVENT_TYPE-}" == "comment-added" ]]; then
508         case "${TEST_CODE}" in
509             *"device"*)
510                 trigger="devicetest"
511                 ;;
512             *"perf"*)
513                 trigger="perftest"
514                 ;;
515             *)
516                 die "Unknown specification: ${TEST_CODE}"
517         esac
518         # Ignore lines not containing the trigger word.
519         comment=$(fgrep "${trigger}" <<< "${GERRIT_EVENT_COMMENT_TEXT}") || true
520         # The vpp-csit triggers trail stuff we are not interested in.
521         # Removing them and trigger word: https://unix.stackexchange.com/a/13472
522         # (except relying on \s whitespace, \S non-whitespace and . both).
523         # The last string is concatenated, only the middle part is expanded.
524         cmd=("grep" "-oP" '\S*'"${trigger}"'\S*\s\K.+$') || die "Unset trigger?"
525         # On parsing error, TEST_TAG_STRING probably stays empty.
526         TEST_TAG_STRING=$("${cmd[@]}" <<< "${comment}") || true
527     fi
528 }
529
530
531 function installed () {
532
533     # Check if the given utility is installed. Fail if not installed.
534     #
535     # Duplicate of common.sh function, as this file is also used standalone.
536     #
537     # Arguments:
538     # - ${1} - Utility to check.
539     # Returns:
540     # - 0 - If command is installed.
541     # - 1 - If command is not installed.
542
543     set -exuo pipefail
544
545     command -v "${1}"
546 }
547
548
549 function reserve_and_cleanup_testbed () {
550
551     # Reserve physical testbed, perform cleanup, register trap to unreserve.
552     # When cleanup fails, remove from topologies and keep retrying
553     # until all topologies are removed.
554     #
555     # Variables read:
556     # - TOPOLOGIES - Array of paths to topology yaml to attempt reservation on.
557     # - PYTHON_SCRIPTS_DIR - Path to directory holding the reservation script.
558     # - BUILD_TAG - Any string suitable as filename, identifying
559     #   test run executing this function. May be unset.
560     # Variables set:
561     # - TOPOLOGIES - Array of paths to topologies, with failed cleanups removed.
562     # - WORKING_TOPOLOGY - Path to topology yaml file of the reserved testbed.
563     # Functions called:
564     # - die - Print to stderr and exit.
565     # - ansible_playbook - Perform an action using ansible, see ansible.sh
566     # Traps registered:
567     # - EXIT - Calls cancel_all for ${WORKING_TOPOLOGY}.
568
569     set -exuo pipefail
570
571     while true; do
572         for topo in "${TOPOLOGIES[@]}"; do
573             set +e
574             scrpt="${PYTHON_SCRIPTS_DIR}/topo_reservation.py"
575             opts=("-t" "${topo}" "-r" "${BUILD_TAG:-Unknown}")
576             python3 "${scrpt}" "${opts[@]}"
577             result="$?"
578             set -e
579             if [[ "${result}" == "0" ]]; then
580                 # Trap unreservation before cleanup check,
581                 # so multiple jobs showing failed cleanup improve chances
582                 # of humans to notice and fix.
583                 WORKING_TOPOLOGY="${topo}"
584                 echo "Reserved: ${WORKING_TOPOLOGY}"
585                 trap "untrap_and_unreserve_testbed" EXIT || {
586                     message="TRAP ATTEMPT AND UNRESERVE FAILED, FIX MANUALLY."
587                     untrap_and_unreserve_testbed "${message}" || {
588                         die "Teardown should have died, not failed."
589                     }
590                     die "Trap attempt failed, unreserve succeeded. Aborting."
591                 }
592                 # Cleanup + calibration checks.
593                 set +e
594                 ansible_playbook "cleanup, calibration"
595                 result="$?"
596                 set -e
597                 if [[ "${result}" == "0" ]]; then
598                     break
599                 fi
600                 warn "Testbed cleanup failed: ${topo}"
601                 untrap_and_unreserve_testbed "Fail of unreserve after cleanup."
602             fi
603             # Else testbed is accessible but currently reserved, moving on.
604         done
605
606         if [[ -n "${WORKING_TOPOLOGY-}" ]]; then
607             # Exit the infinite while loop if we made a reservation.
608             warn "Reservation and cleanup successful."
609             break
610         fi
611
612         if [[ "${#TOPOLOGIES[@]}" == "0" ]]; then
613             die "Run out of operational testbeds!"
614         fi
615
616         # Wait ~3minutes before next try.
617         sleep_time="$[ ( ${RANDOM} % 20 ) + 180 ]s" || {
618             die "Sleep time calculation failed."
619         }
620         echo "Sleeping ${sleep_time}"
621         sleep "${sleep_time}" || die "Sleep failed."
622     done
623 }
624
625
626 function run_pybot () {
627
628     # Run pybot with options based on input variables. Create output_info.xml
629     #
630     # Variables read:
631     # - CSIT_DIR - Path to existing root of local CSIT git repository.
632     # - ARCHIVE_DIR - Path to store robot result files in.
633     # - PYBOT_ARGS, EXPANDED_TAGS - See compose_pybot_arguments.sh
634     # - GENERATED_DIR - Tests are assumed to be generated under there.
635     # Variables set:
636     # - PYBOT_EXIT_STATUS - Exit status of most recent pybot invocation.
637     # Functions called:
638     # - die - Print to stderr and exit.
639
640     set -exuo pipefail
641
642     all_options=("--outputdir" "${ARCHIVE_DIR}" "${PYBOT_ARGS[@]}")
643     all_options+=("--noncritical" "EXPECTED_FAILING")
644     all_options+=("${EXPANDED_TAGS[@]}")
645
646     pushd "${CSIT_DIR}" || die "Change directory operation failed."
647     set +e
648     robot "${all_options[@]}" "${GENERATED_DIR}/tests/"
649     PYBOT_EXIT_STATUS="$?"
650     set -e
651
652     # Generate INFO level output_info.xml for post-processing.
653     all_options=("--loglevel" "INFO")
654     all_options+=("--log" "none")
655     all_options+=("--report" "none")
656     all_options+=("--output" "${ARCHIVE_DIR}/output_info.xml")
657     all_options+=("${ARCHIVE_DIR}/output.xml")
658     rebot "${all_options[@]}" || true
659     popd || die "Change directory operation failed."
660 }
661
662
663 function select_arch_os () {
664
665     # Set variables affected by local CPU architecture and operating system.
666     #
667     # Variables set:
668     # - VPP_VER_FILE - Name of file in CSIT dir containing vpp stable version.
669     # - IMAGE_VER_FILE - Name of file in CSIT dir containing the image name.
670     # - PKG_SUFFIX - Suffix of OS package file name, "rpm" or "deb."
671
672     set -exuo pipefail
673
674     os_id=$(grep '^ID=' /etc/os-release | cut -f2- -d= | sed -e 's/\"//g') || {
675         die "Get OS release failed."
676     }
677
678     case "${os_id}" in
679         "ubuntu"*)
680             IMAGE_VER_FILE="VPP_DEVICE_IMAGE_UBUNTU"
681             VPP_VER_FILE="VPP_STABLE_VER_UBUNTU_BIONIC"
682             PKG_SUFFIX="deb"
683             ;;
684         "centos"*)
685             IMAGE_VER_FILE="VPP_DEVICE_IMAGE_CENTOS"
686             VPP_VER_FILE="VPP_STABLE_VER_CENTOS"
687             PKG_SUFFIX="rpm"
688             ;;
689         *)
690             die "Unable to identify distro or os from ${os_id}"
691             ;;
692     esac
693
694     arch=$(uname -m) || {
695         die "Get CPU architecture failed."
696     }
697
698     case "${arch}" in
699         "aarch64")
700             IMAGE_VER_FILE="${IMAGE_VER_FILE}_ARM"
701             ;;
702         *)
703             ;;
704     esac
705 }
706
707
708 function select_tags () {
709
710     # Variables read:
711     # - WORKING_TOPOLOGY - Path to topology yaml file of the reserved testbed.
712     # - TEST_CODE - String affecting test selection, usually jenkins job name.
713     # - TEST_TAG_STRING - String selecting tags, from gerrit comment.
714     #   Can be unset.
715     # - TOPOLOGIES_DIR - Path to existing directory with available tpologies.
716     # - BASH_FUNCTION_DIR - Directory with input files to process.
717     # Variables set:
718     # - TAGS - Array of processed tag boolean expressions.
719
720     set -exuo pipefail
721
722     # NIC SELECTION
723     start_pattern='^  TG:'
724     end_pattern='^ \? \?[A-Za-z0-9]\+:'
725     # Remove the TG section from topology file
726     sed_command="/${start_pattern}/,/${end_pattern}/d"
727     # All topologies DUT NICs
728     available=$(sed "${sed_command}" "${TOPOLOGIES_DIR}"/* \
729                 | grep -hoP "model: \K.*" | sort -u)
730     # Selected topology DUT NICs
731     reserved=$(sed "${sed_command}" "${WORKING_TOPOLOGY}" \
732                | grep -hoP "model: \K.*" | sort -u)
733     # All topologies DUT NICs - Selected topology DUT NICs
734     exclude_nics=($(comm -13 <(echo "${reserved}") <(echo "${available}"))) || {
735         die "Computation of excluded NICs failed."
736     }
737
738     # Select default NIC tag.
739     case "${TEST_CODE}" in
740         *"3n-dnv"* | *"2n-dnv"*)
741             default_nic="nic_intel-x553"
742             ;;
743         *"3n-tsh"*)
744             default_nic="nic_intel-x520-da2"
745             ;;
746         *"3n-skx"* | *"2n-skx"* | *"2n-clx"*)
747             default_nic="nic_intel-xxv710"
748             ;;
749         *"3n-hsw"* | *"mrr-daily-master")
750             default_nic="nic_intel-xl710"
751             ;;
752         *)
753             default_nic="nic_intel-x710"
754             ;;
755     esac
756
757     sed_nic_sub_cmd="sed s/\${default_nic}/${default_nic}/"
758     sed_nics_sub_cmd="sed -e s/ANDxxv710/ANDnic_intel-xxv710/"
759     sed_nics_sub_cmd+=" | sed -e s/ANDx710/ANDnic_intel-x710/"
760     sed_nics_sub_cmd+=" | sed -e s/ANDxl710/ANDnic_intel-xl710/"
761     sed_nics_sub_cmd+=" | sed -e s/ANDx520-da2/ANDnic_intel-x520-da2/"
762     sed_nics_sub_cmd+=" | sed -e s/ANDx553/ANDnic_intel-x553/"
763     sed_nics_sub_cmd+=" | sed -e s/ANDcx556a/ANDnic_mellanox-cx556a/"
764     sed_nics_sub_cmd+=" | sed -e s/ANDvic1227/ANDnic_cisco-vic-1227/"
765     sed_nics_sub_cmd+=" | sed -e s/ANDvic1385/ANDnic_cisco-vic-1385/"
766     # Tag file directory shorthand.
767     tfd="${JOB_SPECS_DIR}"
768     case "${TEST_CODE}" in
769         # Select specific performance tests based on jenkins job type variable.
770         *"ndrpdr-weekly"* )
771             readarray -t test_tag_array <<< $(sed 's/ //g' \
772                 ${tfd}/mlr-weekly-${NODENESS}-${FLAVOR}.md |
773                 eval ${sed_nics_sub_cmd}) || die
774             ;;
775         *"mrr-daily"* )
776             readarray -t test_tag_array <<< $(sed 's/ //g' \
777                 ${tfd}/mrr-daily-${NODENESS}-${FLAVOR}.md |
778                 eval ${sed_nics_sub_cmd}) || die
779             ;;
780         *"mrr-weekly"* )
781             readarray -t test_tag_array <<< $(sed 's/ //g' \
782                 ${tfd}/mrr-weekly-${NODENESS}-${FLAVOR}.md |
783                 eval ${sed_nics_sub_cmd}) || die
784             ;;
785         * )
786             if [[ -z "${TEST_TAG_STRING-}" ]]; then
787                 # If nothing is specified, we will run pre-selected tests by
788                 # following tags.
789                 test_tag_array=("mrrAND${default_nic}AND1cAND64bANDip4base"
790                                 "mrrAND${default_nic}AND1cAND78bANDip6base"
791                                 "mrrAND${default_nic}AND1cAND64bANDl2bdbase"
792                                 "mrrAND${default_nic}AND1cAND64bANDl2xcbase"
793                                 "!dot1q" "!drv_avf")
794             else
795                 # If trigger contains tags, split them into array.
796                 test_tag_array=(${TEST_TAG_STRING//:/ })
797             fi
798             ;;
799     esac
800
801     # Blacklisting certain tags per topology.
802     #
803     # Reasons for blacklisting:
804     # - ipsechw - Blacklisted on testbeds without crypto hardware accelerator.
805     # TODO: Add missing reasons here (if general) or where used (if specific).
806     case "${TEST_CODE}" in
807         *"2n-skx"*)
808             test_tag_array+=("!ipsechw")
809             ;;
810         *"3n-skx"*)
811             test_tag_array+=("!ipsechw")
812             # Not enough nic_intel-xxv710 to support double link tests.
813             test_tag_array+=("!3_node_double_link_topoANDnic_intel-xxv710")
814             ;;
815         *"2n-clx"*)
816             test_tag_array+=("!ipsechw")
817             ;;
818         *"2n-dnv"*)
819             test_tag_array+=("!ipsechw")
820             test_tag_array+=("!memif")
821             test_tag_array+=("!srv6_proxy")
822             test_tag_array+=("!vhost")
823             test_tag_array+=("!vts")
824             test_tag_array+=("!drv_avf")
825             ;;
826         *"3n-dnv"*)
827             test_tag_array+=("!memif")
828             test_tag_array+=("!srv6_proxy")
829             test_tag_array+=("!vhost")
830             test_tag_array+=("!vts")
831             test_tag_array+=("!drv_avf")
832             ;;
833         *"3n-tsh"*)
834             # 3n-tsh only has x520 NICs which don't work with AVF
835             test_tag_array+=("!drv_avf")
836             test_tag_array+=("!ipsechw")
837             ;;
838         *"3n-hsw"*)
839             # TODO: Introduce NOIOMMU version of AVF tests.
840             # TODO: Make (both) AVF tests work on Haswell,
841             # or document why (some of) it is not possible.
842             # https://github.com/FDio/vpp/blob/master/src/plugins/avf/README.md
843             test_tag_array+=("!drv_avf")
844             # All cards have access to QAT. But only one card (xl710)
845             # resides in same NUMA as QAT. Other cards must go over QPI
846             # which we do not want to even run.
847             test_tag_array+=("!ipsechwNOTnic_intel-xl710")
848             ;;
849         *)
850             # Default to 3n-hsw due to compatibility.
851             test_tag_array+=("!drv_avf")
852             test_tag_array+=("!ipsechwNOTnic_intel-xl710")
853             ;;
854     esac
855
856     # We will add excluded NICs.
857     test_tag_array+=("${exclude_nics[@]/#/!NIC_}")
858
859     TAGS=()
860
861     # We will prefix with perftest to prevent running other tests
862     # (e.g. Functional).
863     prefix="perftestAND"
864     set +x
865     if [[ "${TEST_CODE}" == "vpp-"* ]]; then
866         # Automatic prefixing for VPP jobs to limit the NIC used and
867         # traffic evaluation to MRR.
868         if [[ "${TEST_TAG_STRING-}" == *"nic_"* ]]; then
869             prefix="${prefix}mrrAND"
870         else
871             prefix="${prefix}mrrAND${default_nic}AND"
872         fi
873     fi
874     for tag in "${test_tag_array[@]}"; do
875         if [[ "${tag}" == "!"* ]]; then
876             # Exclude tags are not prefixed.
877             TAGS+=("${tag}")
878         elif [[ "${tag}" == " "* || "${tag}" == *"perftest"* ]]; then
879             # Badly formed tag expressions can trigger way too much tests.
880             set -x
881             warn "The following tag expression hints at bad trigger: ${tag}"
882             warn "Possible cause: Multiple triggers in a single comment."
883             die "Aborting to avoid triggering too many tests."
884         elif [[ "${tag}" != "" && "${tag}" != "#"* ]]; then
885             # Empty and comment lines are skipped.
886             # Other lines are normal tags, they are to be prefixed.
887             TAGS+=("${prefix}${tag}")
888         fi
889     done
890     set -x
891 }
892
893
894 function select_topology () {
895
896     # Variables read:
897     # - NODENESS - Node multiplicity of testbed, either "2n" or "3n".
898     # - FLAVOR - Node flavor string, currently either "hsw" or "skx".
899     # - CSIT_DIR - Path to existing root of local CSIT git repository.
900     # - TOPOLOGIES_DIR - Path to existing directory with available topologies.
901     # Variables set:
902     # - TOPOLOGIES - Array of paths to suitable topology yaml files.
903     # - TOPOLOGIES_TAGS - Tag expression selecting tests for the topology.
904     # Functions called:
905     # - die - Print to stderr and exit.
906
907     set -exuo pipefail
908
909     case_text="${NODENESS}_${FLAVOR}"
910     case "${case_text}" in
911         # TODO: Move tags to "# Blacklisting certain tags per topology" section.
912         # TODO: Double link availability depends on NIC used.
913         "1n_vbox")
914             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*vpp_device*.template )
915             TOPOLOGIES_TAGS="2_node_single_link_topo"
916             ;;
917         "1n_skx" | "1n_tx2")
918             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*vpp_device*.template )
919             TOPOLOGIES_TAGS="2_node_single_link_topo"
920             ;;
921         "2n_skx")
922             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*2n_skx*.yaml )
923             TOPOLOGIES_TAGS="2_node_*_link_topo"
924             ;;
925         "3n_skx")
926             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*3n_skx*.yaml )
927             TOPOLOGIES_TAGS="3_node_*_link_topo"
928             ;;
929         "2n_clx")
930             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*2n_clx*.yaml )
931             TOPOLOGIES_TAGS="2_node_*_link_topo"
932             ;;
933         "2n_dnv")
934             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*2n_dnv*.yaml )
935             TOPOLOGIES_TAGS="2_node_single_link_topo"
936             ;;
937         "3n_dnv")
938             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*3n_dnv*.yaml )
939             TOPOLOGIES_TAGS="3_node_single_link_topo"
940             ;;
941         "3n_hsw")
942             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*3n_hsw*.yaml )
943             TOPOLOGIES_TAGS="3_node_single_link_topo"
944             ;;
945         "3n_tsh")
946             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*3n_tsh*.yaml )
947             TOPOLOGIES_TAGS="3_node_single_link_topo"
948             ;;
949         *)
950             # No falling back to 3n_hsw default, that should have been done
951             # by the function which has set NODENESS and FLAVOR.
952             die "Unknown specification: ${case_text}"
953     esac
954
955     if [[ -z "${TOPOLOGIES-}" ]]; then
956         die "No applicable topology found!"
957     fi
958 }
959
960
961 function select_vpp_device_tags () {
962
963     # Variables read:
964     # - TEST_CODE - String affecting test selection, usually jenkins job name.
965     # - TEST_TAG_STRING - String selecting tags, from gerrit comment.
966     #   Can be unset.
967     # Variables set:
968     # - TAGS - Array of processed tag boolean expressions.
969
970     set -exuo pipefail
971
972     case "${TEST_CODE}" in
973         # Select specific device tests based on jenkins job type variable.
974         * )
975             if [[ -z "${TEST_TAG_STRING-}" ]]; then
976                 # If nothing is specified, we will run pre-selected tests by
977                 # following tags. Items of array will be concatenated by OR
978                 # in Robot Framework.
979                 test_tag_array=()
980             else
981                 # If trigger contains tags, split them into array.
982                 test_tag_array=(${TEST_TAG_STRING//:/ })
983             fi
984             ;;
985     esac
986
987     # Blacklisting certain tags per topology.
988     #
989     # Reasons for blacklisting:
990     # - avf - AVF is not possible to run on enic driver of VirtualBox.
991     # - vhost - VirtualBox does not support nesting virtualization on Intel CPU.
992     case "${TEST_CODE}" in
993         *"1n-vbox"*)
994             test_tag_array+=("!avf")
995             test_tag_array+=("!vhost")
996             ;;
997         *)
998             ;;
999     esac
1000
1001     TAGS=()
1002
1003     # We will prefix with devicetest to prevent running other tests
1004     # (e.g. Functional).
1005     prefix="devicetestAND"
1006     if [[ "${TEST_CODE}" == "vpp-"* ]]; then
1007         # Automatic prefixing for VPP jobs to limit testing.
1008         prefix="${prefix}"
1009     fi
1010     for tag in "${test_tag_array[@]}"; do
1011         if [[ ${tag} == "!"* ]]; then
1012             # Exclude tags are not prefixed.
1013             TAGS+=("${tag}")
1014         else
1015             TAGS+=("${prefix}${tag}")
1016         fi
1017     done
1018 }
1019
1020 function untrap_and_unreserve_testbed () {
1021
1022     # Use this as a trap function to ensure testbed does not remain reserved.
1023     # Perhaps call directly before script exit, to free testbed for other jobs.
1024     # This function is smart enough to avoid multiple unreservations (so safe).
1025     # Topo cleanup is executed (call it best practice), ignoring failures.
1026     #
1027     # Hardcoded values:
1028     # - default message to die with if testbed might remain reserved.
1029     # Arguments:
1030     # - ${1} - Message to die with if unreservation fails. Default hardcoded.
1031     # Variables read (by inner function):
1032     # - WORKING_TOPOLOGY - Path to topology yaml file of the reserved testbed.
1033     # - PYTHON_SCRIPTS_DIR - Path to directory holding Python scripts.
1034     # Variables written:
1035     # - WORKING_TOPOLOGY - Set to empty string on successful unreservation.
1036     # Trap unregistered:
1037     # - EXIT - Failure to untrap is reported, but ignored otherwise.
1038     # Functions called:
1039     # - die - Print to stderr and exit.
1040     # - ansible_playbook - Perform an action using ansible, see ansible.sh
1041
1042     set -xo pipefail
1043     set +eu  # We do not want to exit early in a "teardown" function.
1044     trap - EXIT || echo "Trap deactivation failed, continuing anyway."
1045     wt="${WORKING_TOPOLOGY}"  # Just to avoid too long lines.
1046     if [[ -z "${wt-}" ]]; then
1047         set -eu
1048         warn "Testbed looks unreserved already. Trap removal failed before?"
1049     else
1050         ansible_playbook "cleanup" || true
1051         python3 "${PYTHON_SCRIPTS_DIR}/topo_reservation.py" -c -t "${wt}" || {
1052             die "${1:-FAILED TO UNRESERVE, FIX MANUALLY.}" 2
1053         }
1054         WORKING_TOPOLOGY=""
1055         set -eu
1056     fi
1057 }
1058
1059
1060 function warn () {
1061
1062     # Print the message to standard error.
1063     #
1064     # Arguments:
1065     # - ${@} - The text of the message.
1066
1067     set -exuo pipefail
1068
1069     echo "$@" >&2
1070 }